#![cfg_attr(feature="nightly", feature(test))] 
#![cfg_attr(feature="nightly", feature(never_type))] 

#![allow(dead_code)]
#![allow(unused_macros)]

#[cfg(all(feature="nightly", test))] extern crate test; 
#[macro_use] extern crate serde;
#[macro_use] extern crate lazy_static;
#[macro_use] extern crate log;
#[macro_use] extern crate mopa;
#[macro_use] extern crate cfg_if;
#[macro_use] extern crate ad_hoc_iter;
#[macro_use] extern crate maud;
#[macro_use] extern crate hex_literal;

#[allow(unused_imports)]
use std::convert::{TryFrom, TryInto};
#[allow(unused_imports)]
use color_eyre::{
    eyre::{
	WrapErr as _,
	self,
	eyre,
    },
    SectionExt, Help
};

#[macro_use] mod ext; use ext::*;

mod service;
mod bytes;
mod delta; //unused now, but tests still use it, so...
mod hard_format;
mod mnemonic;
mod defaults;

mod template;

mod user;
mod post;
mod state;

fn install() -> eyre::Result<()>
{
    color_eyre::install()?;
    pretty_env_logger::init();

    Ok(())
}


#[tokio::main]
async fn main() -> eyre::Result<()> {
    install()?;
    trace!("log initialised");

    
    
    Ok(())
}
