use super::*;
use std::collections::{HashMap, HashSet};
use std::sync::Arc;
use tokio::sync::RwLock;

use user::{User, UserID};
use post::Post;

mod freeze;
pub use freeze::*;

#[derive(Debug)]
struct Posts
{
    users: HashMap<UserID, RwLock<User>>,
    posts: HashMap<UserID, MaybeVec<RwLock<Post>>>,
}

#[derive(Debug)]
struct Inner
{
    posts: RwLock<Posts>,
}

/// Contains all posts and users
#[derive(Debug, Clone)]
pub struct State(Arc<Inner>);
